<template>
  <div>
    <b-navbar toggleable="lg" type="dark" variant="dark">
      <b-navbar-brand to="/">Mini-ERP</b-navbar-brand>

      <!--
      In order to see the buttons when the navbar is on mobile
      https://bootstrap-vue.org/docs/components/navbar
      -->
      <b-navbar-toggle target="nav-collapse"></b-navbar-toggle>

      <!-- In order to collapse the navbar on mobile -->
      <b-collapse id="nav-collapse" is-nav>

        <b-navbar-nav>
          <b-nav-item :to="{name: 'client'}">Client</b-nav-item>
          <b-nav-item :to="{name: 'company'}">Company</b-nav-item>
          <b-nav-item :to="{name: 'employee'}">Employee</b-nav-item>
          <b-nav-item :to="{name: 'product'}">Product</b-nav-item>
          <b-nav-item :to="{name: 'provider'}">Provider</b-nav-item>

          <b-nav-item-dropdown text="Transactions" right>
            <b-dropdown-item>
              <!-- Not yet implemented
            <router-link to="/providerCompany" style="color: #4e555b">
              provider -> company
            </router-link>
            -->
            </b-dropdown-item>
            <b-dropdown-item>
              <router-link to="/companyClient" style="color: #4e555b">
                company → client
              </router-link>
            </b-dropdown-item>
          </b-nav-item-dropdown>
        </b-navbar-nav>

        <b-navbar-nav class="ml-auto">
          <b-button class="mr-2" id="navLoginButton" variant="outline-primary" @click="login()" v-if="!this.getUserByStore().isLogged">
            <b-icon icon="lock"></b-icon>
            Login
          </b-button>
          <b-button class="mr-2" variant="outline-primary" @click="logout()" v-if="this.getUserByStore().isLogged">
            <b-icon icon="unlock"></b-icon>
            Logout
          </b-button>
          <b-button variant="outline-primary" @click="registration()" v-if="!this.getUserByStore().isLogged">
            <b-icon icon="inbox-fill"></b-icon>
            Registration
          </b-button>
        </b-navbar-nav>
      </b-collapse>
      <Login ref="loginModalComponent"/>
      <Logout ref="logoutModalComponent"/>
      <Registration ref="registrationModalComponent"/>
    </b-navbar>
  </div>
</template>

<script>
import Vuex from "vuex";

import Login from '../../components/modals/Login';
import Logout from '../../components/modals/Logout';
import Registration from '../../components/modals/Registration';
import Store from '../../stores/Store';

export default {
  name: 'Nav',
  components: {
    Login,
    Logout,
    Registration
  },
  store: Store,
  methods: {
    ...Vuex.mapGetters([
      'getUserByStore'
    ]),
    login() {
      this.$refs.loginModalComponent.showModalAction();
    },
    logout() {
      this.$refs.logoutModalComponent.showModalAction();
    },
    registration() {
      this.$refs.registrationModalComponent.showModalAction();
    }
  }
}
</script>
